
#include "instructions.h"
using namespace std;


    WhileInstruction::WhileInstruction()
    {
    }

    WhileInstruction::~WhileInstruction()
    {
    }




    WhileProgram::WhileProgram()
    {
    }

    WhileProgram::~WhileProgram()
    {
        for(vector<WhileInstruction*>::iterator i = Instructions.begin(); i != Instructions.end(); i++)
            delete *i;
    }

    void WhileProgram::Execute(ExecutionContext* context)
    {
        for(vector<WhileInstruction*>::iterator i = Instructions.begin(); i != Instructions.end(); i++)
            (*i)->Execute(context);
    }




    WhileLoop::WhileLoop(string Variable, int CmpNumber, WhileProgram* Block)
        : WhileInstruction()
    {
        this->Variable = Variable;
        this->CmpNumber = CmpNumber;
        this->Block = Block;
    }

    WhileLoop::~WhileLoop()
    {
        delete Block;
    }

    void WhileLoop::Execute(ExecutionContext* context)
    {
        int temp = 0;
        if(context->Variables.find(Variable) != context->Variables.end())
            temp = context->Variables[Variable];

        while(temp != CmpNumber)
        {
            Block->Execute(context);
            if(context->Variables.find(Variable) != context->Variables.end())
                temp = context->Variables[Variable];
        }
    }




    Assignment::Assignment(string DstVariable, string SrcVariable, int Added)
        : WhileInstruction()
    {
        this->DstVariable = DstVariable;
        this->SrcVariable = SrcVariable;
        this->Added = Added;
    }

    Assignment::~Assignment()
    {
    }

    void Assignment::Execute(ExecutionContext* context)
    {
        int tmp = 0;
        if(context->Variables.find(SrcVariable) != context->Variables.end())
            tmp = context->Variables[SrcVariable];
        context->Variables[DstVariable] = tmp + Added;
    }

